const serializer = require('../src/util/serializer');
const expect = require('chai').expect;

describe('Message Serializer Unit Tests', () => {
    describe('Messages Over UDP', () => {
        it('should serialize a session', () => {
            const session = {
                game_mode: 3,
                inet: true,
                maxpl: 4,
                nation: 'de',
                numpl: 1,
                password: false,
                players: [
                    'noBlubb'
                ],
                server_addr: '84.200.106.154',
                server_name: 'EmergencyX',
                server_port: 58282,
                vmaj: 1,
                vmin: 0,
                vtype: 'f'
            };

            // TODO(rs): is the sort order important?
            // -> restore from original captures
            // ....game_mode=3;inet=1;maxpl=4;nation=de;numpl=1;password=0;players=.(10).noBlubb..(-1).;
            // server_addr=84.200.106.154;server_name=EmergencyX;server_port=58282;vmaj=1;vmin=0;vtype=f
            const response = Buffer.of(0x67, 0x61, 0x6d, 0x65, 0x5f, 0x6d, 0x6f, 0x64, 0x65, 0x3d, 0x33, 0x3b,
                0x69, 0x6e, 0x65, 0x74, 0x3d, 0x31, 0x3b, 0x6d, 0x61, 0x78, 0x70, 0x6c, 0x3d, 0x34, 0x3b, 0x6e,
                0x61, 0x74, 0x69, 0x6f, 0x6e, 0x3d, 0x64, 0x65, 0x3b, 0x6e, 0x75, 0x6d, 0x70, 0x6c, 0x3d, 0x31,
                0x3b, 0x70, 0x61, 0x73, 0x73, 0x77, 0x6f, 0x72, 0x64, 0x3d, 0x30, 0x3b, 0x70, 0x6c, 0x61, 0x79,
                0x65, 0x72, 0x73, 0x3d, 0xa7, 0x28, 0x31, 0x30, 0x29, 0x1b, 0x6e, 0x6f, 0x42, 0x6c, 0x75, 0x62,
                0x62, 0x1c, 0xa7, 0x28, 0x2d, 0x31, 0x29, 0x1b, 0x3b, 0x73, 0x65, 0x72, 0x76, 0x65, 0x72, 0x5f,
                0x61, 0x64, 0x64, 0x72, 0x3d, 0x38, 0x34, 0x2e, 0x32, 0x30, 0x30, 0x2e, 0x31, 0x30, 0x36, 0x2e,
                0x31, 0x35, 0x34, 0x3b, 0x73, 0x65, 0x72, 0x76, 0x65, 0x72, 0x5f, 0x6e, 0x61, 0x6d, 0x65, 0x3d,
                0x45, 0x6d, 0x65, 0x72, 0x67, 0x65, 0x6e, 0x63, 0x79, 0x58, 0x3b, 0x73, 0x65, 0x72, 0x76, 0x65,
                0x72, 0x5f, 0x70, 0x6f, 0x72, 0x74, 0x3d, 0x35, 0x38, 0x32, 0x38, 0x32, 0x3b, 0x76, 0x6d, 0x61,
                0x6a, 0x3d, 0x31, 0x3b, 0x76, 0x6d, 0x69, 0x6e, 0x3d, 0x30, 0x3b, 0x76, 0x74, 0x79, 0x70, 0x65,
                0x3d, 0x66);
            const serialized = serializer.session(session);
            expect(serialized).to.be.deep.equal(response);
        })
    });

    describe('Player Names Field', () => {
        it('should encode a single player name', () => {
            const players = ['Marco'];
            const value = Buffer.of(0xa7, 0x28, 0x31, 0x30,
                0x29, 0x1b, 0x4d, 0x61, 0x72, 0x63, 0x6f, 0x1c,
                0xa7, 0x28, 0x2d, 0x31, 0x29, 0x1b);
            const serialized = serializer.players(players);;
            expect(serialized).to.be.deep.equal(value);
        });

        it('should encode multiple player names', () => {
            const players = ['Rexfire', 'seba3fire', '911 Giovinny'];
            const value = Buffer.of(0xa7, 0x28, 0x31, 0x30,
                0x29, 0x1b, 0x52, 0x65, 0x78, 0x66, 0x69, 0x72,
                0x65, 0x1c, 0xa7, 0x28, 0x2d, 0x31, 0x29, 0x1b,
                0x2c, 0x20, 0x73, 0x65, 0x62, 0x61, 0x33, 0x66,
                0x69, 0x72, 0x65, 0x2c, 0x20, 0x39, 0x31, 0x31,
                0x20, 0x47, 0x69, 0x6f, 0x76, 0x69, 0x6e, 0x6e,
                0x79);
            const serialized = serializer.players(players);
            expect(serialized).to.be.deep.equal(value);
        });

        it('should not modify source object (regression test #1)', () => {
            const players = ['Rexfire', 'seba3fire', '911 Giovinny'];
            serializer.players(players);
            expect(players).to.be.deep.equal(['Rexfire', 'seba3fire', '911 Giovinny']);
        });
    });
});
